#ifndef EDGEPROVIDER_H_
#define EDGEPROVIDER_H_

#include "Edge.h"


class EdgeProvider {
  public:
    virtual ~EdgeProvider() {}
    
    virtual const Edge* getEdge(size_t id) const = 0;
    virtual size_t getEdgeCount() const = 0;
    
    virtual void moveEdge(size_t id, float x, float y) {}
    virtual void rotateEdge(size_t id, Vertex m, float a) {}
};

#endif /*EDGEPROVIDER_H_*/
