#ifndef VERTEXPROVIDER_H_
#define VERTEXPROVIDER_H_

#include "Vertex.h"


class LevelVertex;

class VertexProvider {
  public:
    virtual ~VertexProvider() {}
    
    virtual const Vertex* getVertex(size_t id) const = 0;
    virtual size_t getVertexCount() const = 0;
    
    virtual void moveVertex(size_t id, float x, float y) {}
    virtual void rotateVertex(size_t id, Vertex m, float a) {}
    
    virtual bool canConnectVertex(size_t id) const {return false;}
    virtual size_t connectVertex(size_t id) {return id;}
};

#endif /*VERTEXPROVIDER_H_*/
